package com.gingersoft.supply_chain.mvp.contract;

import com.gingersoft.gsa.cloud.common.bean.BaseResult;
import com.gingersoft.supply_chain.mvp.bean.BasicUnitBean;
import com.gingersoft.supply_chain.mvp.bean.DeputyUnitBean;
import com.jess.arms.mvp.IView;
import com.jess.arms.mvp.IModel;

import java.util.List;

import io.reactivex.Observable;
import okhttp3.RequestBody;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 12/28/2020 16:05
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
public interface FoodUnitPageContract {
    //对于经常使用的关于UI的方法可以定义到IView中,如显示隐藏进度条,和显示文字消息
    interface View extends IView {
        void loadBasicUnitAdapter(List<BasicUnitBean> basicUnitBeans);

        void addBasicUnit(BasicUnitBean basicUnitBeans);

        void loadDeputyUnitAdapter(List<DeputyUnitBean> deputyUnitBeans);

        void initTopBar(String title);

        void setMainUnit(String content);

        void callBackDeputyUnit(List<DeputyUnitBean> deputyUnitBeans);

        void deleteDeputyUnit(int position);

        void deleteUnitKey(int position);
    }

    //Model层定义接口,外部只需关心Model返回的数据,无需关心内部细节,即是否使用缓存
    interface Model extends IModel {
        /**
         * 獲取基本單位集合
         *
         * @param brandId      品牌id
         * @param restaurantId 餐廳ID
         * @return
         */
        Observable<BaseResult> getDeputyUnitList(int brandId, int restaurantId);

        /**
         * 批量修改副單位
         *
         * @return
         */
        Observable<BaseResult> updateDeputyUnitList(RequestBody requestBody);

        /**
         * 修改副單位
         */
        Observable<BaseResult> updateDeputyUnit(RequestBody requestBody);
        /**
         * 添加下面快捷輸入的單位
         * @return
         */
        Observable<BaseResult> addBasicUnit(RequestBody requestBody);

        Observable<BaseResult> deleteUnitKey(int id);
    }
}
